///
/// Keys for music library or other persistence needs.
///	@file		musickeys.h - pianod
///	@author		Perette Barella
///	@date		2020-04-15
///	@copyright	Copyright 2020 Devious Fish.  All rights reserved.
///

/// Keys for persisting library indexes.
namespace MusicStorage {
    extern const char *LibraryMedia;
    extern const char *LibraryPlaylists;
    
    extern const char *PlaylistName;
    extern const char *PlaylistId;
    extern const char *PlaylistEnabled;
    extern const char *PlaylistSelector;
    extern const char *PlaylistSeeds;
    
    extern const char *MediaArtists;
    extern const char *MediaPath;
    extern const char *MediaLastScan;

    extern const char *ArtistName;
    extern const char *ArtistId;
    extern const char *ArtistAlbums;
    extern const char *ArtistPath;
    
    extern const char *AlbumName;
    extern const char *AlbumId;
    extern const char *AlbumIsCompilation;
    extern const char *AlbumSongs;
    extern const char *AlbumPath;

    extern const char *SongName;
    extern const char *SongId;
    extern const char *SongTrackNumber;
    extern const char *SongDuration;
    extern const char *SongYear;
    extern const char *SongLastPlayed;
    extern const char *SongGenre;
    extern const char *SongPath;
}

/// Element and attribute keys for ratings.
//namespace SongRatingKey {
//    extern const char *Type;
//}
